
#ifndef GOV_H
#define GOV_H

#include "SymbolTable.h"
#include "Tree.h"
#include <map>

string sym(Tree* t);

class ProbCnt
{
 public:
  ProbCnt() : prob(0),cnt(0){}
  int prob;
  int cnt;
};

typedef map<stIndex,ProbCnt> StcMap;
/* to compute p(a|b), p-hat(a|b)-D
   divide it by |b|.
   to get the backed off prob get N(a,.)/N(.,.);
   multiply the baed off p by the lam from oneMlab
*/

/* for p(a|b,c(b))
   start out the same with p-hat(a|b)-D0 and divide by |b|
   
*/
#define CNTfITR(stcm) stcm->second.cnt
#define PRBfITR(stcm) stcm->second.prob
#define CNTfANS(stcm) stcm.cnt

class StMapC //for p(a|b) stores info associaated with b
{
 public:
  StMapC() : c(0), cp(0), clss(-1){for(int i=0;i<3;i++)nplus[i]=0;}
  int c;  //|b|, |c(b)|
  int cp;  //|b|, |c(b)|
  int clss; //c(b)
  int nplus[3]; //stores N(b,.)
  float oneMlam; //for p(a|b) stores (1-lam(b))
  StcMap stcMap;  //stores p-hat(a|b), p-hat(a|c(b))
  int    probc(stIndex gov){
    StcMap::iterator stcmi=stcMap.find(gov);
    if(stcmi==stcMap.end())return -1;
    else return stcmi->second.prob;
  }
  int&    probcc(stIndex gov){
    StcMap::iterator stcmi=stcMap.find(gov);
    if(stcmi==stcMap.end())
      return stcMap[gov].prob;
    else return stcmi->second.prob;
  }
  int&    cntc(stIndex gov){
    StcMap::iterator stcmi=stcMap.find(gov);
    if(stcmi==stcMap.end())
      return stcMap[gov].cnt;
    else return stcmi->second.cnt;
  }
};

typedef map<stIndex,StMapC> StstMap;

class Gov
{
 public:
  void readStems();
  float pGov(stIndex ante,stIndex gov,int synno,int posno);
  float rawProbs(stIndex ante, stIndex gov, int synno,int pos,float prb);
  void addGovRel(stIndex np,stIndex gov,int synno,int posno);
  void writeGovs(ostream& os);
  void   postComp(istream& is);
  void wclassRead(istream& is);
  stIndex getStem(stIndex wrd);
  static stIndex posHead(Tree* t,int ind);
  static stIndex sGov(Tree* t);
  float  ds[4];
  int ndotdot;
  StstMap ststMap;
  StstMap ststcMap; //stores info for c(b);
  StcMap n1pMap;  //stores Ncb(a,.)
  map<stIndex,stIndex> stems;
};  

#endif

